BlockHunt
====

# ![Thanks to ColeRule for making this awesome banner!](http://g2f.nl/0qheg35 "Thanks to ColeRule for making this awesome banner!")

## Introduction

Hide and seek is a popular game mode on Minecraft that allows you to hide as blocks and disguise as normal props from
seekers. This plugin allows you to do that but with a lot more features added on such as: shops, stats etc...

This plugin has been heavily inspired from the gamemode "PropHunt", from the game, "Garry's Mod".

**Download and try this plugin out for yourself!**

### Downloads

| Branch  | Plugin version | Compatiable Minecraft version | Build status                                                               | Download                                                                                      |
|---------|----------------|-------------------------------|----------------------------------------------------------------------------|-----------------------------------------------------------------------------------------------|
| Release | **v0.2.1**     | **v1.12.2**                   | [![Build Status](https://jenkins.addstar.com.au/job/Blockhunt/badge/icon)] | [DOWNLOAD](https://jenkins.addstar.com.au/job/Blockhunt/lastSuccessfulBuild/artifact/target/) |

#### This plugin requires you to download and install two addinonal plugins! ([Lib's Disguises](https://www.spigotmc.org/resources/libs-disguises.81/) and [ProtocolLib](http://dev.bukkit.org/bukkit-plugins/protocollib/))

### Support

| Method                       | Link                                                         |
|------------------------------|--------------------------------------------------------------|
| **Issues/Tickets on GitHub** | [Click Here](https://github.com/AddstarMC/BlockHunt/issues/) |

### Features

* Custom wand for selection arena.
* Multiple arenas.
* **Join/Leave signs!**
* Arena full bypass.
* Configurable blocks.
* **Solid blocks like the Hives!**
* Enable commands per arena.
* Executing commands on win.
* **Shop with tokens!**
* Instant respawn.
* **_And more!_**

## Commands & Permissions

_**Note:** Instead of using /BlockHunt you could use:_

* /bh
* /hideandseek
* /seekandfind (from my old plugin)

<> = Required [] = Optional

| Command                                                            | Description                                       | Permission                  | Default allowed                                 |
|--------------------------------------------------------------------|---------------------------------------------------|-----------------------------|-------------------------------------------------|
| `/BlockHunt [info/i]`                                              | Displays the plugin's info.                       | blockhunt.info              | All players have this permission from default._ |
| `/BlockHunt <help/h>`                                              | Shows a list of commands.                         | blockhunt.help              | All players have this permission from default._ |
| `/BlockHunt <reload/r>`                                            | Reloads all configs.                              | blockhunt.reload            | blockhunt.admin                                 |                                                 
| `/BlockHunt <join/j> <arenaName>`                                  | Joins a BlockHunt game.                           | blockhunt.join              | blockhunt.player                                |                                                 
| `/BlockHunt <leave/l>`                                             | Leave a BlockHunt game.                           | blockhunt.leave             | blockhunt.player                                |
| `/BlockHunt <list/li>`                                             | Shows a list of available arenas.                 | blockhunt.list              | blockhunt.player                                |
| `/BlockHunt <shop/sh>`                                             | Opens the BlockHunt shop.                         | blockhunt.shop              | blockhunt.player                                |                                                 
| `/BlockHunt <start/go> <arenaName>`                                | Forces an arena to start.                         | blockhunt.start             | blockhunt.moderator                             |                                                 
| `/BlockHunt <wand/w>`                                              | Gives you the wand selection tool.                | blockhunt.create            | blockhunt.admin                                 |                                                 
| `/BlockHunt <create/c> <arenaName>`                                | Creates an arena from your selection.             | blockhunt.create            | blockhunt.admin                                 |                                                 
| `/BlockHunt <set/s> <arenaName>`                                   | Opens a panel to set settings.                    | blockhunt.set               | blockhunt.moderator                             |                                                 
| `/BlockHunt <setWarp/sw> <lobby/hiders/seekers/spawn> <arenaName>` | Sets warps for your arena.                        | blockhunt.setWarp           | blockhunt.moderator                             |                                                 
| `/BlockHunt <remove/delete> <arenaName>`                           | Deletes an Arena.                                 | blockhunt.remove            | blockhunt.admin                                 |                                                 
| `/BlockHunt <tokens/t> <set/add/take> <%playerName%> <amount>`     | Change someones tokens.                           | blockhunt.tokens            | blockhunt.admin                                 |                                                 
|                                                                    | Able to join full games.                          | blockhunt.joinfull          | blockhunt.moderator                             | 
|                                                                    | Able to join/leave using join/leave signs.        | blockhunt.joinsign          | blockhunt.player                                |                                                 
|                                                                    | Able to create a join/leave sign.                 | blockhunt.signcreate        | blockhunt.moderator                             |                                                 
|                                                                    | Gives you the BlockChooser.                       | blockhunt.shop.blockchooser | blockhunt.admin                                 |                                                 
|                                                                    | Gives you the ability to do all commands in-game. | blockhunt.allcommands       | Operators                                       |

### Other special permissions

| Permission            | Description                                                        |
|-----------------------|--------------------------------------------------------------------|
| `blockhunt.*`         | All BlockHunt permissions.                                         |
| `blockhunt.player`    | All player related permissions.                                    |
| `blockhunt.moderator` | All moderator related permissions.                                 |
| `blockhunt.admin`     | All admin related permissions.                                     |
| `*`                   | All permissions on your server, including BlockHunt's permissions. |

## How to set up?

Use this video to manage your way through the set-up phase!

<a href="http://www.youtube.com/watch?feature=player_embedded&v=msPQ1UMiHWg
" target="_blank"><img src="http://img.youtube.com/vi/msPQ1UMiHWg/0.jpg"
alt="" width="240" height="180" border="10" /></a>

**Thanks to [Koz4Christ](https://www.youtube.com/user/koz4christ/) for this video!**

### Textual guide

To start setting up your arena, start by using the `/bh wand` command to get the setup wand. Mark the corners of a
square containing your entire arena, like you'd create a WorldGuard region. Right-click with the wand on one corner,
and then left-click with the wand on the opposite corner. Make sure one corner is below the bottom of the arena, and
that the other is above the top of the arena.

Use `/bh create \<name>` to create your new arena with name \<name>. Use `/bh set \<name>` to get a GUI for setting the
properties of the arena. You can set the maximum number of players that can play at once, the minimum amount of players
for a game to start, the amount of seekers required to start, the amount of seconds to keep the players in the lobby (
allowing other players to join) before starting the arena, the number of seconds to wait until seekers can start
seeking, the amount of time a game will last, the amount of seconds between each time the number of remaining hiders is
announced, the number of seconds before the game ends the hiders will be given swords.

### Arena interface descriptions

#### maxPlayers

The maximum amount of players that can join this arena.

#### minPlayers

The minimum amount of players required for a round to start.

#### amountSeekersOnStart

The number of players made into seekers when the game starts.

#### timeInLobbyUntilStart

The amount of seconds to wait in the lobby until the game actually starts. During this time, players can use an item in
their inventory to choose their hide block. Other players can join during this time, until the game starts.

#### waitingTimeSeeker

The number of seconds seekers have to wait before they are allowed to start seeking. This is basically how long the
seekers count for until they start searching for the hiders.

#### gameTime

The amount of seconds a game will last. If the hiders are alive after this time, they win.

#### blockAnnouncerTime

The amount of seconds

#### sword

The amount of seconds to wait before allowing hiders to defend themselves with a wooden sword.